program FORWARD_SYN_REC
	use sep
	use mem_mod
	use fbi_mod
	use initialize
	implicit none

	!===========================================================================
	!	Allocate and Initialize
	!---------------------------------------------------------------------------
	integer                             	:: nt, nz, nx, isou
	integer                             	:: sou_nx, sou_ox, sou_dx, sou_z, sou_x
	integer                             	:: rec_nx, rec_ox, rec_dx, rec_z, rec_x
	real                                	:: dt, dz, oz, dx, ox, ot
	real, dimension(:), allocatable     	:: wavelet
	real, dimension(:,:,:), allocatable	:: full_wave, full_wave_stack
	real, dimension(:,:), allocatable	:: rec_wave

	!===========================================================================
	call init_forward(nz,nx,nt,dz,dx,dt,oz,ox,ot,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z,wavelet)
	call mem_alloc3d(full_wave, nz, nx, nt)
	call mem_alloc3d(full_wave_stack, nz, nx, nt)
	call mem_alloc2d(rec_wave, nt, rec_nx)
	full_wave_stack=0.0

	!---------------------------------------------------------------------------
	do isou=1, sou_nx
		full_wave=0.0
		! Nonlinear operator: source => full nonlinear data (equation 9)
		call forward_wavefield(full_wave,rec_wave, isou) 
		call sep_write(rec_wave)
		full_wave_stack = full_wave_stack + full_wave 
	end do

	!---------------------------------------------------------------------------
	if (exist_file('full_wave_stack')) call sep_write(full_wave_stack,'full_wave_stack')
	!===========================================================================
end program
