program MAIN

!===========================================================================
!   Allocate and Initialize
!---------------------------------------------------------------------------
  use sep
  use mem_mod
  use fbi_mod
  use levelset_mod
  use initialize
  implicit none

  integer                             	:: nt, nz, nx, wfld_j, i, niter
  integer                             	:: sou_nx, sou_ox, sou_dx, sou_z, sou_x
  integer                             	:: rec_nx, rec_ox, rec_dx, rec_z, rec_x, irec
  integer                             	:: bc1, bc2, bc3, bc4
  real                                	:: dt, dz, oz, dx, ox, ot, v1, tstep, vstep, mu, objval, alpha, beta
  real, dimension(:), allocatable     	:: wavelet
  real, dimension(:,:), allocatable   	:: phi_in, vel_in, phi_out, vel_out

!---------------------------------------------------------------------------
 call init_main(nz,nx,nt,dz,dx,dt,oz,ox,ot,bc1,bc2,bc3,bc4,wfld_j,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z,wavelet,tstep,vstep, niter)


!===========================================================================
	! Read (phi_in, vel_in) and recorded data 
	call mem_alloc2d(phi_in, nz, nx)
	call sep_read(phi_in,'phi_in')


	! Check for background velocity model input
	if (exist_file('vel_in')) then
		call mem_alloc2d(vel_in, nz, nx)
		call sep_read(vel_in,'vel_in')
	else
		write(0,*) "You need to provide a background velocity input"
	end if
	

	! Allocate phi_out, vel_out
	call mem_alloc2d(phi_out, nz, nx)
	call mem_alloc2d(vel_out, nz, nx)
	phi_out=0.0
	vel_out=0.0

!---------------------------------------------------------------------------




!===========================================================================
!   Loop over all levelset iterations
!---------------------------------------------------------------------------
	if (exist_file('phi_out')) call sep_write(phi_in, 'phi_out')
	do i=1,niter
		write(0,*) " "
		write(0,*) i, " out of ", niter, " steps."
		call levelset(phi_in, vel_in, phi_out, vel_out)
		phi_in = phi_out
		vel_in = vel_out
		phi_out=0.0
		vel_out=0.0
	end do



!===========================================================================

end program
