
program MODEL1_BUILDER
use sep
implicit none

!===============================================================
real, dimension(:,:), allocatable	:: model, vel_back_true
integer					:: nz, nx, iz, ix, cz, cx
real					:: q1, rad, dist, a, dz, dx, oz, ox


! Allocate the internal arrays / dimensions
 call sep_init()
 call from_param("q1",q1,15.0)  ! Salt velocity
 call from_param("n1",nz,100)
 call from_param("n2",nx,100)
 call from_param("d1",dz)
 call from_param("d2",dx)
 call from_param("o1",oz)
 call from_param("o2",ox)
 call from_param("cz",cz,50)
 call from_param("cx",cx,50)
 call from_param("rad",rad,10.0)


allocate(model(nz,nx),vel_back_true(nz,nx))


! Check for background velocity model input
if (exist_file('vel_in')) then
	call sep_read(vel_back_true,'vel_in')
else
	write(0,*) "You need to provide a background velocity input"
end if


! Build model #1
model = vel_back_true
do iz=1,nz
	do ix=1,nx
		a = (ix-cx)**2 + (iz-cz)**2
		dist = sqrt(a)
		if (dist <= rad) then
			model(iz,ix) = q1
		end if
	end do
end do


! Output the initial levelset
 call sep_write(model)
 call to_history("n1", nz)
 call to_history("o1", oz)
 call to_history("d1", dz)
 call to_history("n2", nx)
 call to_history("o2", ox)
 call to_history("d2", dx)
 call to_history("label1", 'z')
 call to_history("label2", 'x')
 call sep_close()

end program
