
program phi0_builder
use sep
implicit none

!===============================================================
real, dimension(:,:), allocatable	:: phi0
integer					:: nz, nx, iz, ix, cz, cx
real					:: rad, dist, a, dz, dx, oz, ox, perturbation

! Allocate the internal arrays / dimensions
 call sep_init()
 call from_param("n1",nz,100)
 call from_param("n2",nx,100)

 call from_param("d1",dz)
 call from_param("d2",dx)

 call from_param("o1",oz)
 call from_param("o2",ox)

 call from_param("cz",cz,50)
 call from_param("cx",cx,50)
 call from_param("rad",rad)
 call from_param("perturbation",perturbation)



allocate(phi0(nz,nx))
! Build the initial phi surface
do iz=1,nz
	do ix=1,nx
		a = (ix-cx)**2 + (iz-cz)**2
		dist = sqrt(a)
		phi0(iz,ix) = (rad + perturbation) - dist  	! Phi > 0 in salt, and Phi < 0 outside the salt
		!phi0(iz,ix) = dist - (rad + perturbation)	! Phi < 0 in salt, and Phi > 0 outside the salt
	end do
end do



! Output the initial levelset
 call sep_write(phi0)
 call to_history("n1", nz)
 call to_history("o1", oz)
 call to_history("d1", dz)
 call to_history("n2", nx)
 call to_history("o2", ox)
 call to_history("d2", dx)
 call to_history("label1", 'z')
 call to_history("label2", 'x')
 call sep_close()

end program
