module planesearch_mod
	implicit none
	integer, private				:: n1, n2, n3
	real, dimension(:,:,:), pointer, private	:: tomodata, bounddata
	contains


	subroutine planesearch_init(tomodata_in, bounddata_in, n1_in, n2_in, n3_in)
		real, dimension(:,:,:), target		:: tomodata_in, bounddata_in
		integer					:: n1_in, n2_in, n3_in
		n1 = n1_in
		n2 = n2_in
		n3 = n3_in
		tomodata   => tomodata_in
		bounddata  => bounddata_in
	end subroutine



	function planesearch_op(adj, add, model, data) result(stat)
		logical,intent(in)	:: adj,add
		real,dimension(:) 	:: model, data
		integer			:: stat
		call planesearch_op2(adj, add, model, data)
		stat=0
	end function 




	subroutine planesearch_op2(adj, add, model, data)
		integer				:: i, j, k
		real, dimension(2)		:: model
		real, dimension(n1,n2,n3) 	:: data
		logical, intent(in)		:: adj, add

		if (adj) then
			if (.not. add) then
				model = 0.0
			end if			
			do i=1,n1
				do j=1,n2
					do k=1,n3
						model(1) = model(1) + data(i,j,k)*tomodata(i,j,k)
						model(2) = model(2) + data(i,j,k)*bounddata(i,j,k)
					end do
				end do
			end do
		else
			if (.not. add) then
				data = 0.0
			end if	
			do i=1,n1
				do j=1,n2
					do k=1,n3
						data(i,j,k) = data(i,j,k) + model(1)*tomodata(i,j,k)
						data(i,j,k) = data(i,j,k) + model(2)*bounddata(i,j,k)
					end do
				end do
			end do
		end if
	end subroutine


end module
