program salt_overlay
use sep
implicit none


real					:: Vsalt
integer					:: i, j, k, nz, nx, nz2, nx2
real, allocatable, dimension(:,:)	:: vel_back, vel_salt, vel_full

 call sep_init()
 call from_history("n1", nz)
 call from_history("n2", nx)

 call from_aux("vel_salt","n1", nz2, 1)
 call from_aux("vel_salt","n2", nx2, 1)
 call from_param("q1",Vsalt, 4500.0)

 if ( (nx2 .ne. nx) .or. (nz2 .ne. nz) ) then
	call erexit("Dimensions of the vel_back do not match the vel_salt")
 end if

 allocate( vel_back(nz,nx), vel_full(nz,nx), vel_salt(nz,nx) )
 call sep_read(vel_back)
 call sep_read(vel_salt,"vel_salt")

 vel_full = vel_back
 do i=1,nz
	do j=1,nx
		if (vel_salt(i,j)==Vsalt) then
			vel_full(i,j) = Vsalt
		end if
	end do
 end do
 call sep_write(vel_full)

end program
